/*
 * tsys01.h
 *
 *  Created on: Jul 30, 2014
 *      Author: JMBrinkhus
 */

#include <stdio.h>
#include "xiic_l.h"


#ifndef TSYS01_H_
#define TSYS01_H_

#define CRC_POLY					(0x131)	// CRC Polynomial: X^8 + X^5 + X^4 + 1

// TSYS01 I2C Commands
#define TSYS01_I2C_CMD_RESET					(0x1E)
#define TSYS01_I2C_CMD_READ_PROM_BASE			(0xA2)
#define TSYS01_I2C_CMD_START_ADC				(0x48)
#define TSYS01_I2C_CMD_READ_ADC					(0x00)

// TSYS01 Enumerations
typedef enum tsys01_address{
	tsys01_i2c_address_csb_0 = 0x77,			// 1110_111x
	tsys01_i2c_address_csb_1 = 0x76				// 1110_110x
}tsys01_address;
typedef enum tsys01_status{
	tsys01_status_ok = 0,
	tsys01_status_i2c_transfer_error = 1
}tsys01_status;

#endif /* TSYS01_H_ */

// External variables
extern 	u32 			tsys01_axi_address;
extern 	tsys01_address 	tsys01_i2c_address;
extern 	u32 			tsys01_prom_coeffs[6];

// Function Declarations
void tsys01_init(u32 axi_address);
void tsys01_set_address(tsys01_address addr);
tsys01_status tsys01_reset(void);
tsys01_status tsys01_read_prom(void);
tsys01_status tsys01_read_temperature(float* temperature);
